> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Create and Invite User

POST https://api.x.flatfile.com/v1/users/invite
Content-Type: application/json

Creates and invites a new user to your account.

Reference: https://reference.flatfile.com/api-reference/users/create-and-invite

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects an UserCreateAndInviteRequest.

- `email` (string, required)
- `name` (string, required)
- `actorRoles` (list of AssignActorRoleRequest, required)

## Response

### 200

- `data` (UserWithRoles, required)

## Types

### AssignActorRoleRequest

- `roleId` (string, required) — Role ID
- `resourceId` (ResourceIdUnion, required)

### UserWithRoles

- `accountId` (string, required) — Account ID
- `actorRoles` (list of ActorRoleResponse, required)
- `createdAt` (datetime, required)
- `email` (string, required)
- `id` (string, required) — User ID
- `idp` (string, required)
- `metadata` (map from string to any, required)
- `name` (string, required)
- `updatedAt` (datetime, required)
- `dashboard` (integer, optional)
- `idpRef` (string, optional)
- `lastSeenAt` (datetime, optional)

### ResourceIdUnion

### ActorRoleResponse

- `id` (string, required) — Actor Role ID
- `roleId` (string, required) — Role ID
- `actorId` (ActorIdUnion, required)
- `resourceId` (ResourceIdUnion, required)
- `createdAt` (datetime, required)
- `updatedAt` (datetime, required)

### ActorIdUnion

## Examples

**Request**

```json
{
  "email": "john.smith@example.com",
  "name": "John Smith",
  "actorRoles": [
    {
      "roleId": "us_rol_YOUR_ID",
      "resourceId": "us_acc_YOUR_ID"
    },
    {
      "roleId": "us_rol_YOUR_ID",
      "resourceId": "us_env_YOUR_ID"
    }
  ]
}
```

**Response**

```json
{
  "data": {
    "accountId": "us_acc_YOUR_ID",
    "actorRoles": [
      {
        "id": "us_acr_YOUR_ID",
        "roleId": "us_rol_YOUR_ID",
        "actorId": "us_usr_YOUR_ID",
        "resourceId": "us_acc_YOUR_ID",
        "createdAt": "2021-01-01T00:00:00Z",
        "updatedAt": "2021-01-01T00:00:00Z"
      },
      {
        "id": "us_acr_YOUR_ID",
        "roleId": "us_rol_YOUR_ID",
        "actorId": "us_ag_YOUR_ID",
        "resourceId": "us_env_YOUR_ID",
        "createdAt": "2021-01-01T00:00:00Z",
        "updatedAt": "2021-01-01T00:00:00Z"
      }
    ],
    "createdAt": "2023-10-30T16:59:45.735Z",
    "email": "john.smith@example.com",
    "id": "us_usr_YOUR_ID",
    "idp": "FRONTEGG",
    "metadata": {},
    "name": "john.smith",
    "updatedAt": "2023-10-30T16:59:45.735Z",
    "dashboard": 2,
    "idpRef": "ab1cf38e-e617-4547-b37d-376a7ac9e554",
    "lastSeenAt": "2023-10-30T16:59:45.735Z"
  }
}
```

**SDK Code**

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/users/invite"

payload = {
    "email": "john.smith@example.com",
    "name": "John Smith",
    "actorRoles": [
        {
            "roleId": "us_rol_YOUR_ID",
            "resourceId": "us_acc_YOUR_ID"
        },
        {
            "roleId": "us_rol_YOUR_ID",
            "resourceId": "us_env_YOUR_ID"
        }
    ]
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.users.createAndInvite({
    email: "john.smith@example.com",
    name: "John Smith",
    actorRoles: [{
            roleId: "us_rol_YOUR_ID",
            resourceId: "us_acc_YOUR_ID"
        }, {
            roleId: "us_rol_YOUR_ID",
            resourceId: "us_env_YOUR_ID"
        }]
});

```

```go Example0
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/users/invite"

	payload := strings.NewReader("{\n  \"email\": \"john.smith@example.com\",\n  \"name\": \"John Smith\",\n  \"actorRoles\": [\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_acc_YOUR_ID\"\n    },\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_env_YOUR_ID\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/users/invite")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"email\": \"john.smith@example.com\",\n  \"name\": \"John Smith\",\n  \"actorRoles\": [\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_acc_YOUR_ID\"\n    },\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_env_YOUR_ID\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.x.flatfile.com/v1/users/invite")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"email\": \"john.smith@example.com\",\n  \"name\": \"John Smith\",\n  \"actorRoles\": [\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_acc_YOUR_ID\"\n    },\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_env_YOUR_ID\"\n    }\n  ]\n}")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.x.flatfile.com/v1/users/invite', [
  'body' => '{
  "email": "john.smith@example.com",
  "name": "John Smith",
  "actorRoles": [
    {
      "roleId": "us_rol_YOUR_ID",
      "resourceId": "us_acc_YOUR_ID"
    },
    {
      "roleId": "us_rol_YOUR_ID",
      "resourceId": "us_env_YOUR_ID"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/users/invite");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"email\": \"john.smith@example.com\",\n  \"name\": \"John Smith\",\n  \"actorRoles\": [\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_acc_YOUR_ID\"\n    },\n    {\n      \"roleId\": \"us_rol_YOUR_ID\",\n      \"resourceId\": \"us_env_YOUR_ID\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "email": "john.smith@example.com",
  "name": "John Smith",
  "actorRoles": [
    [
      "roleId": "us_rol_YOUR_ID",
      "resourceId": "us_acc_YOUR_ID"
    ],
    [
      "roleId": "us_rol_YOUR_ID",
      "resourceId": "us_env_YOUR_ID"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/users/invite")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```